<!DOCTYPE html>
<html lang="en">
    <head>
        <title>Red Black Tree</title>
        <meta name="viewport" content="width=device-width,height=device-height,initial-scale=1.0" />
        <meta charset="utf-8" />
        <style>
         .exp {
         display: none;
         }
         table {
         font-family: arial, sans-serif;
         border-collapse: collapse;
         width: 100%;
         text-align: center;
         }
         th {
         background-color:#2780C6;
         text-align: center !important;
         color:#fff;
         }
         #headings {
         background-color:#2780C6;
         text-align: center;
         color:#fff;
         }
         td {
         border: 1px solid #dddddd;
         padding: 8px;
         text-align: center;
         height:20px;
         }
         tr:hover {
         background-color: #ddd;
         }
      </style>
        
        <!-- Google Tag Manager -->
        <script class="gtm">
          window.dataLayer = window.dataLayer || [];
          
          window.dataLayer.push ({
          'labName': 'Data Structures – 2',
          'discipline': 'Computer Science and Engineering',
          'college': 'IIITH',
          'phase': '3',
          'expName': 'Red Black Tree',
          'expShortName': 'red-black-tree'
          });
          
          
          (function(w,d,s,l,i){w[l]=w[l]||[];w[l].push({'gtm.start':
          new Date().getTime(),event:'gtm.js'});var f=d.getElementsByTagName(s)[0],
          j=d.createElement(s),dl=l!='dataLayer'?'&l='+l:'';j.async=true;j.src=
          'https://www.googletagmanager.com/gtm.js?id='+i+dl;f.parentNode.insertBefore(j,f);
         })(window,document,'script','dataLayer','GTM-W59SWTR');
        </script>
        <!-- End Google Tag Manager -->
    </head>
    <body>
        <!-- Google Tag Manager (noscript) -->
        <noscript class="gtm">
          <iframe height="0" width="0"
            src="https://www.googletagmanager.com/ns.html?id=GTM-W59SWTR"
            style="display:none;visibility:hidden">
          </iframe>
        </noscript>
        <!-- End Google Tag Manager (noscript) -->

        <div class="exp" title="Red Black Tree Experiment">
            <div class="longt">
                <h1 class="hlongt">Introduction to Red Black Tree</h1>
            </div>
            <div class="preamble">         
                <div class="art txt" title="Estimation">
                    <div class="longt">
                        <h2 class="hlongt">Estimated Time</h2>
                    </div>
                    <div class="art-body">
                        <p>1 hour</p>
                    </div>
                </div>
                <div class="art req" title="Introduction">
                    <div class="longt">
                        <h2 class="hlongt">Introduction to Red Black Tree</h2>
                    </div>
                    <div class="description">
                        <p>Video introduction to Red Black Tree experiment
                            should be displayed here..!</p>
                    </div>            
                </div>
                <div class="art txt" title="Prerequisites">
                    <div class="longt">
                        <h2 class="hlongt">Prerequisites of the Experiment</h2>
                    </div>
                    <div class="art-body">
                        <ul>
                            <li>
                                Basic knowledge of
                                <ul>
                                    <li>
                                        <a href="https://www.cs.cmu.edu/~adamchik/15-121/lectures/Trees/trees.html">Binary Trees</a>
                                    </li>
                                    <li>
                                        <a href="https://www.geeksforgeeks.org/binary-search-tree-data-structure/">Binary Search Trees</a>
                                    </li>
                                    <li>
                                        <a href="https://www.geeksforgeeks.org/tag/avl-tree/">AVL Trees</a>
                                    </li>
                                </ul>
                            </li>
                            <li>And above all, a curiosity to learn and explore..!</li>
                        </ul>
                    </div>
                </div>
                <div class="art txt" title="Overview">
                    <div class="longt">
                        <h2 class="hlongt">Overview of the Experiment</h2>
                    </div>
                    <div class="art-body">
                        <p>The experiment features a series of
                            modules with video lectures, hands-on
                            practice exercises and quizzes to self
                            analyze.
                        </p>
                    </div>
                </div>
                <div class="art txt" title="Learning Objectives">
                    <div class="longt">
                        <h2 class="hlongt">Learning Objectives of the Experiment</h2>
                    </div>
                    <div class="art-body">
                        <p>In this experiment, you will be able to do the following:<br>
                            <ul>
                                <li>
                                    Structure, representation and Implementation of Red Black Tree.
                                </li>
                                <li>
                                    Red Black Tree Properties.    
                                </li>
                                <li>
                                    Insert, Search and Delete
                                    operations on Red Black
                                    Tree, their algorithms,
                                    time and space
                                    complexity analysis.
                                </li>
                                <li>
                                    Advantages of Red Black Tree over other self-balancing trees.   
                                </li>
                            </ul>
                        </p>
                    </div>
                </div>
            </div>
            <div class="lu" title="Pre-Test">
                <div class="longt">
                    <h1 class="hlongt">Pre-test of the Experiment</h1>
                </div>

                <div class="preamble">
                    <div class="art txt" title="Estimation">
                        <div class="longt">
                            <h2 class="hlongt">Estimated Time</h2>
                        </div>
                        <div class="art-body">
                            <p>10 minutes</p>
                        </div>
                    </div>

                    <div class="art txt" title="Instructions">
                        <div class="longt">
                            <h2 class="hlongt">Instructions for Pre-test</h2>
                        </div>
                        <div class="art-body">
                            <p>Pretest includes questions on
                               basics of binary trees and
                               balanced binary trees. All
                               questions are single option
                               correct.
                            </p>
                        </div>
                    </div>
                </div>

                <div class="quiz" title="Pre Test Quiz">
                    <div class="longt">
                        <h2 class="hlongt">Pre Test Quiz of the Experiment</h2>
                    </div>
                    
                    <div class="mcq">
                        <div class="preamble">
                            <div class="art txt" title="qi">
                                <div class="art-body">
                                    <p>Q1. What is an AVL tree?</p>
                                </div>
                            </div>
                        </div>
                        
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="qi-c2">
                                    <div class="art-body">
                                        <p>(A) A tree which is unbalanced and is a height balanced tree. </p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="qi-c3">
                                    <div class="art-body">
                                        <p>(B) A tree with three children.
                                        </p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="qi-c4">
                                    <div class="art-body">
                                        <p>(C) A tree with atmost 3 children. </p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        
                        <div class="choice" data-correct="true">
                            <div class="preamble">
                                <div class="art txt" title="qi-c1">
                                    <div class="art-body">
                                        <p>(D) A tree which is balanced and is a height balanced tree. </p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        
                        <div class="explanation">
                            <div class="art txt" title="Explanation">
                                <div class="art-body">
                                    <p>It is a self balancing tree with height difference atmost 1..</p>
                                </div>
                            </div>
                        </div>
                    </div>
                    
                    <div class="mcq">
                        <div class="preamble">
                            <div class="art txt" title="qi">
                                <div class="art-body">
                                    <p>Q2. What is the maximum difference in heights between the leafs of a AVL tree is possible?</p>
                                </div>
                            </div>
                        </div>
                        
                        <div class="choice" data-correct="true">
                            <div class="preamble">
                                <div class="art txt" title="qi-c1">
                                    <div class="art-body">
                                        <p>(A) log(n) where n is the number of nodes
                                        </p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="qi-c4">
                                    <div class="art-body">
                                        <p>(B) atmost 1 </p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="qi-c3">
                                    <div class="art-body">
                                        <p>(C) 0 or 1
                                        </p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="qi-c2">
                                    <div class="art-body">
                                        <p>(D) n where n is the number of nodes
                                        </p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        
                        <div class="explanation">
                            <div class="art txt" title="Explanation">
                                <div class="art-body">
                                    <p>At every level we can form a tree with difference in height between
                                        subtrees to be atmost 1 and so there can be log(n) such levels since
                                        height of AVL tree is log(n).</p>
                                </div>
                            </div>
                        </div>
                    </div>
                    
                    <div class="mcq">
                        <div class="preamble">
                            <div class="art txt" title="qi">
                                <div class="art-body">
                                    <p>Q3. What is the maximum height of an AVL tree with p nodes?</p>
                                </div>
                            </div>
                        </div>
                        
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="qi-c3">
                                    <div class="art-body">
                                        <p>(A) p </p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        
                        <div class="choice" data-correct="true">
                            <div class="preamble">
                                <div class="art txt" title="qi-c1">
                                    <div class="art-body">
                                        <p>(B) log(p) </p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="qi-c4">
                                    <div class="art-body">
                                        <p>(C) p/2 </p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="qi-c2">
                                    <div class="art-body">
                                        <p>(D) log(p)/2 </p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        
                        <div class="explanation">
                            <div class="art txt" title="Explanation">
                                <div class="art-body">
                                    <p>In all traversals mentioned in the question, left subtee is
                                        traversed before the right subtree.</p>
                                </div>
                            </div>
                        </div>
                    </div>
                    
                    <div class="mcq">
                        <div class="preamble">
                            <div class="art txt" title="qi">
                                <div class="art-body">
                                    <p>Q4. Why do we need a binary tree which is height balanced?</p>
                                </div>
                            </div>
                        </div>
                        
                        <div class="choice" data-correct="true">
                            <div class="preamble">
                                <div class="art txt" title="qi-c1">
                                    <div class="art-body">
                                        <p>(A) To avoid formation of skew trees
                                        </p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="qi-c2">
                                    <div class="art-body">
                                        <p>(B) To save memory
                                        </p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="qi-c4">
                                    <div class="art-body">
                                        <p>(C) To simplify storing </p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="qi-c3">
                                    <div class="art-body">
                                        <p>(D) To attain faster memory access
                                        </p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        
                        <div class="explanation">
                            <div class="art txt" title="Explanation">
                                <div class="art-body">
                                    <p>In real world dealing with random values is often not possible, the
                                        probability that u are dealing with non random values(like
                                        sequential) leads to mostly skew trees, which leads to worst case.
                                        hence we make height balance by rotations.</p>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <div class="lu" title="Red Black Tree">
                <div class="longt">
                    <h2 class="hlongt">Basics of Red Black Tree</h2>
                </div>
                <div class="preamble">
                    <div class="art txt" title="Estimation">
                        <div class="longt">
                            <h2 class="hlongt">Estimated Time</h2>
                        </div>
                        <div class="art-body">
                            <p>15 minutes</p>
                        </div>
                    </div>
                    <div class="art txt" title="Introduction">
                        <div class="longt">
                            <h2 class="hlongt">Introduction to Red Black Trees</h2>
                        </div>
                        <div class="art-body">
                            <p>Welcome to this module on Red black Tree!
                                Take a look at what you will go
                                through the module.
                                <ul>
                                    <li>What is Red Black Tree?</li>
                                    <li>Representation of Red Black Tree</li>
                                    <li>A quiz to check your
                                        understanding of
                                        structure of Red Black Tree</li>
                                </ul>
                            </p>
                        </div>
                    </div>
                </div>
                <div class="task" title="Red Black Tree Basics">
                    <div class="longt">
                        <h2 class="hlongt">Basics</h2>
                    </div>
                    <div class="art req" title="Red Black Tree Video Introduction">
                        <div class="longt">
                            <h2 class="hlongt">Welcome to Red Black Tree Experiment!</h2>
                        </div>
                        <div class="description">
                            <p>Video introduction to Red Black Tree experiment
                                should be displayed here..!</p>
                        </div>            
                    </div>
                    <div class="art txt" title="Basics">
                        <div class="longt">
                            <h2 class="hlongt">What is Red Black Tree?</h2>
                        </div>
                        <div class="art-body">
                            <p>
                                A Red-Black Tree is a binary
                                search tree with one extra
                                attribute for each node: <b>the colour</b>,
                                which is either red or
                                black. We also need to keep
                                track of the parent of each
                                node.
                            </p>
                        </div>
                    </div>
                    <div class="art req" title="Basics of Red Black tree"> 
                        <div class="longt">
                            <h2 class="hlongt">Basics of Red Black Tree</h2> 
                        </div> 
                        <div class="description"> 
                            <p>basics of Tree traversal video should be displayed here</p> 
                        </div>             
                    </div> 
                    <div class="art req" title="Basic Red Black Tree">
                        <div class="longt">
                            <h2 class="hlongt">Pictorial Representation of a Red Black Tree</h2>
                        </div>
                        <div class="description">
                            Pictorial Representation of Basic RBT
                        </div>
                    </div>
                </div>
                <div class="task" title="Structure and Properties">    
                    <div class="longt">
                        <h2 class="hlongt">Structure and Properties</h2>
                    </div>
                    <div class="art txt" title="Structure of Red Black Tree">
                        <div class="longt">
                            <h2 class="hlongt">Structure of Red Black Tree</h2>
                        </div>
                        <div class="art-body">
                            Each node contains the following fields:
                            <ul>
                                <li>key</li>
                                <li>left – pointer to the root of left subtree.</li>
                                <li>right – pointer to the root of right subtree.</li>
                                <li>parent – pointer to the parent node.</li>
                                <li>color- color of the node, either <b>RED</b> or <b>BLACK</b></li>
                            </ul>
                        </div>
                    </div>      
                    <div class="art txt" title="Properties of Red Black Tree">
                        <div class="longt">
                            <h2 class="hlongt">Properties of Red Black Tree</h2>
                        </div>
                        <div class="art-body">
                            <ul>
                                <li>Each node is either red or black.</li>
                                <li>The root of the tree is always black.</li>
                                <li>All leaves are null (Depicted as NIL in diagrams) and they are black.</li>
                                <li>If a node is red, then its parent is black.</li>
                                <li>Any path from a given
                                node to any of its
                                descendant leaves contains
                                the same amount of black
                                nodes. This is sometimes
                                known as the <b>black-depth</b>.</li>
                            </ul>
                        </div>
                    </div>
                    <div class="art txt" title="Imposing of properties">
                        <div class="longt">
                            <h2 class="hlongt">Why do we impose such properties ? </h2>
                        </div>
                        <div class="art-body">
                            <p>
                            <ul>
                            <li>
                            Binary Search Tree in worst can
                            can have a complexity of O(n) in
                            insert and delete.  The
                            Red-Black trees guarantee a
                            O(log(n)) in insert, delete
                            (even in worst case). </li> 
                            <li>
                            They are balanced search trees and
                            therefore balance themselves to
                            always maintain a height of
                            log(n),due to such restrictions. </li>
                            </ul>
                            </p>
                        </div>
                    </div> 
                    <div class="art req" title="Properties Of Red Black Tree">
                        <div class="longt">
                            <h2 class="hlongt">Pictorial Representation of properties of a Red Black Tree</h2>
                        </div>
                        <div class="description">
                            Pictorial Representation of properties of Basic RBT
                        </div>
                    </div>
                </div>
                <div class="quiz" title="Basics of Structure and Properties Quiz">
                    <div class="longt">
                        <h2 class="hlongt">Post Test Quiz of the Experiment</h2>
                    </div>
                    
                    <div class="mcq">
                        <div class="preamble">
                            <div class="art txt" title="qi">
                                <div class="art-body">
                                    <p>Q1. What is the special property of Red-Black trees and what should be the root always be?</p>
                                </div>
                            </div>
                        </div>
                        
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="qi-c3">
                                    <div class="art-body">
                                        <p>(A) A pointer to next node. </p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="qi-c4">
                                    <div class="art-body">
                                        <p>(B) A color which is either green or black. </p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        
                        <div class="choice" data-correct="true">
                            <div class="preamble">
                                <div class="art txt" title="qi-c1">
                                    <div class="art-body">
                                        <p>(C) A color which is either red or black and root should always be
                                            black color only.
                                        </p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="qi-c2">
                                    <div class="art-body">
                                        <p>(D) The height of the tree.
                                        </p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        
                        <div class="explanation">
                            <div class="art txt" title="Explanation">
                                <div class="art-body">
                                    <p>An extra attribute
                                        which is a color red
                                        or black is
                                        used. root is black
                                        because if it is red
                                        then one of
                                        red-black tree
                                        property which
                                        states that number
                                        of black nodes from
                                        root to null nodes
                                        must be same, will
                                        be violated.</p>
                                </div>
                            </div>
                        </div>
                    </div>
                    
                    <div class="mcq">
                        <div class="preamble">
                            <div class="art txt" title="qi">
                                <div class="art-body">
                                    <p>Q2. When to prefer Red-black trees over AVL trees?
                                    </p>
                                </div>
                            </div>
                        </div>
                        
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="qi-c3">
                                    <div class="art-body">
                                        <p>(A) When log(nodes) time complexity is needed. </p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="qi-c4">
                                    <div class="art-body">
                                        <p>(B) When more search operations are needed. </p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        
                        <div class="choice" data-correct="true">
                            <div class="preamble">
                                <div class="art txt" title="qi-c1">
                                    <div class="art-body">
                                        <p>(C) When there are more insertions or deletions.
                                        </p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="qi-c2">
                                    <div class="art-body">
                                        <p>(D) When tree must be balanced.
                                        </p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        
                        <div class="explanation">
                            <div class="art txt" title="Explanation">
                                <div class="art-body">
                                    <p>Though both trees are balanced, when there are more insertions and
                                        deletions to make the tree balanced, AVL trees should have more
                                        rotations, it would be better to use red-black. but if more search
                                        is required AVL trees should be used.</p>
                                </div>
                            </div>
                        </div>
                    </div>
                    
                </div>
            </div>
            <div class="lu" title="Red Black Tree Operations">
                <div class="longt">
                    <h2 class="hlongt">Red Black Tree Insertion</h2>
                </div>
                <div class="preamble">
                    <div class="art txt" title="Estimation">
                        <div class="longt">
                            <h2 class="hlongt">Estimated Time</h2>
                        </div>
                        <div class="art-body">
                            <p>25 minutes</p>
                        </div>
                    </div>
                    <div class="art txt" title="Introduction">
                        <div class="longt">
                            <h2 class="hlongt">Introduction to rotations,insertions,deletions and search in red black trees</h2>
                        </div>
                        <div class="art-body">
                            <p>Welcome to this module on insertions in red black trees.! Take a look at what you
                                will go through in this module.
                                <ul>
                                    <li>Left and right rotations of trees.</li>
                                    <li>Insertion of nodes in a red black tree.</li>
                                    <li>Deletion of nodes in a red black tree.</li>
                                    <li>Searching of nodes in a red black tree.</li>
                                    <li>Interactive  Exercise</li>
                                    <li>A quiz to check your
                                        understanding of
                                        operations in red black trees</li>
                                </ul>
                            </p>
                        </div>
                    </div>
                </div>
                <div class="task" title="Rotation">
                    <div class="longt">
                        <h2 class="hlongt">Rotation in Red Black Tree.</h2>
                    </div>
                    <div class="art txt" title="Basics of Rotation">
                        <div class="longt">
                            <h2 class="hlongt">What is rotation in search trees ?</h2>
                        </div>
                        <div class="art-body">
                            <p>
                                Tree rotation is an
                                operation on a search tree
                                that changes the structure
                                without interfering with the
                                order of the elements.
                            </p>
                        </div>
                    </div>
                    <div class="art txt" title="Purpose">
                        <div class="longt">
                            <h2 class="hlongt">Why do we need to do rotations in Red Black Trees</h2>
                        </div>
                        <div class="art-body">
                            The maximum height of the red black tree is O(log n).
                            To Maintain this height, rotation operations is performed.
                            Rotation alters the stucture of the tree by rearranging subtrees.
                            There are two kinds of rotations performed.
                            <ul>
                                <li>Left Rotation</li>
                                <li>Right Rotation</li>
                            </ul>
                        </div>
                    </div>
                    <div class="art txt" title="Left Rotation Algorithm">
                        <div class="longt">
                            <h2 class="hlongt">Left Rotation Algorithm</h2>
                        </div>
                        <div class="art-body">
                            Let the node to be rotated is x.
                            Let the right subtree of node x be y.
                            <ul>
                                <li>Turn y's left subtree into x's right subtree.</li>
                                <li> Link the parent of x to y.</li>
                                <li>  Put  x as left subtree of y.</li>
                                <li>  Set parent of x as y.</li>
                            </ul>
                        </div>
                    </div>
                    <div class="art txt" title="Right Rotation Algorithm">
                        <div class="longt">
                            <h2 class="hlongt">Right Rotation Algorithm</h2>
                        </div>
                        <div class="art-body">
                            Let the node to be rotated is x.
                            Let the left subtree of node x be y.
                            <ul>
                                <li>Turn y's right subtree into x's leftt subtree.</li>
                                <li> Link the parent of x to y.</li>
                                <li>  Put  x as right subtree of y.</li>
                                <li>  Set parent of x as y.</li>
                            </ul>
                        </div>
                    </div>
                    <div class="art req" title="Left Rotation in Binary Search Tree">
                        <div class="longt">
                            <h2 class="hlongt">Pictorial Representation of properties of a Left Rotation</h2>
                        </div>
                        <div class="description">
                            Pictorial Representation of properties of Basic RBT
                        </div>
                    </div>
                    <div class="art req" title="Right Rotation in Binary Search Tree">
                        <div class="longt">
                            <h2 class="hlongt">Pictorial Representation of properties of a Right Rotation</h2>
                        </div>
                        <div class="description">
                            <p>Pictorial Representation of properties of Basic RBT</p>
                        </div>
                    </div>
                </div>
                <div class="task" title="Insertion">
                    <div class="longt">
                        <h2 class="hlongt">Insertion in Red Black Tree.</h2>
                    </div>
                    <div class="art req" title="Insertion Algorithm">
                        <div class="longt">
                            <h2 class="hlongt">Insertion Algorithm</h2>
                        </div>
                        <div class="description">
                            <p>Basics of Insertion algorithm video should be
                                displayed here..!</p>
                        </div>            
                    </div>
                    <div class="art txt" title="Uncle and grandparent nodes">
                        <div class="longt">
                            <h2 class="hlongt">Uncle and grandparent nodes in a red black tree</h2>
                        </div>
                        <div class="art-body">
                            <p>
                            <ul>
                            <li>Let Z be the node being studied. </li>
                            <li>Uncle nodes refer to the sibling nodes of the parent node of Z. </li>
                            <li>Grandparent node refer to the parent node  of the parent node of Z. </li>
                            </ul>
                            </p>
                        </div>            
                    </div>
                    <div class="art req" title="Pictorial Representation of Uncle,parent,grandparent in Red Black Tree">
                        <div class="longt">
                            <h2 class="hlongt">Pictorial Representation of uncle,parent and grandparent nodes in a red black tree</h2>
                        </div>
                        <div class="description">
                            Pictorial Representation of properties of Basic RBT
                        </div>
                    </div>
                    <div class="art txt" title="Insertion Algorithm">
                        <div class="longt">
                            <h2 class="hlongt">Insertion Algorithm</h2>
                        </div>
                        <div class="art-body">
                            <p>
                            Let Z be the node to be inserted.
                            <ul>
                                <li>Insert Node and color it red.</li>
                                <li>Recolor and rotate nodes to fix violations</li>
                            </ul>
                            There are 4 subcases to be handled to fix violations.<br>
                            Case 1.Z is the root node.<br>
                            <ul>
                                <li>Color the node as black.</li>
                            </ul>
                            Case 2.The uncle node of Z is red.<br>
                            <ul>
                                <li>Recolor the parent and grandparent of Z to fix violations.</li>
                            </ul>
                            Case 3.The uncle node of Z is black and Z, parent node of Z  and grandparent node of Z form a triangle.<br>
                            <ul>
                                <li>Rotate parent of Z.</li>
                            </ul>
                            Case 4.The uncle node of Z is black and Z, parent node of Z  and grandparent node of Z form a line.<br>
                            <ul>
                                <li>Rotate the grandparent of Z and recolor the parent and grandparent of Z to fix violations.</li>
                            </ul>
                            </p>
                        </div>
                    </div>
                </div>       
                <div class="task" title="Deletion">
                    <div class="longt">
                        <h2 class="hlongt">Deletion</h2>
                    </div>
                    <div class="art req" title="Deletion Algorithm">
                        <div class="longt">
                            <h2 class="hlongt">Deletion Algorithm</h2>
                        </div>
                        <div class="description">
                            <p>Basics of Deletion algorithm video should be
                                displayed here..!</p>
                        </div>            
                    </div>      
                    <div class="art txt" title="Deletion in a Binary Search Tree">
                        <div class="longt">
                            <h2 class="hlongt">Recap of Deletion in a Binary Search Tree</h2>
                        </div>
                        <div class="art-body">
                            <p>In a Binary Search Tree, we end up deleting a node which is leaf or has one child.
                            </p>
                            <p>
                                The internal nodes are deleted by replacing it by its inorder successor.
                            </p>
                        </div>
                    </div>
                    <div class="art txt" title="Deletion in a Red Black Tree">
                        <div class="longt">
                            <h2 class="hlongt">Deletion in a Red Black Tree</h2>
                        </div>
                        <div class="art-body">
                            <p>Initially, we will delete a
                                node just like we delete a
                                node in a normal binary
                                search tree. Here are the
                                cases we will look at:<br>
                                <b>1) Red leaf node<br>
                                2) Black node, with one red
                                child node<br>
                                3) Black leaf node</b><br>
                                <p>
                                <ul>
                                <li>
                                In fithe rst case, the
                                normal binary search tree
                                delete is
                                sufficient. Removing a red
                                node does not change the
                                black depths of any node,
                                nor create a red child for
                                any red node. </li>
                                <li>
                                In the second case, after we
                                complete the binary search
                                tree delete, we must simply
                                recolor the child node of
                                the deleted node to
                                black. Changing this color
                                adds one to the black depths
                                of each node in the subtree
                                of the deleted node,
                                restoring the equality of
                                the black depths of all
                                external nodes. Also,
                                changing a node to black
                                does not violate any of the
                                other Red-Black Tree
                                specifications.</li>
                                <li>
                                Neither of the strategies
                                mentioned above are adequate
                                for dealing with the third
                                case. Instead, when we patch
                                in the child of the deleted
                                node in this case, in order
                                to temporarily preserve the
                                black depth property, we
                                will color this child node a
                                fictitious "double black"
                                color. </li>
                                <li>
                                Before we discuss how to
                                deal with "double black"
                                nodes, let's real quickly
                                justify why the cases above
                                are the only cases we will
                                deal with. First off, we
                                will only delete nodes with
                                0 or 1 child. Neither
                                colored node can have one
                                black child. If it did, the
                                black height of the node's
                                null child would not be
                                proper. Further more, a red
                                node can NOT have a red
                                child. These observations
                                narrow the cases to the
                                situations listed above.</li>
                                <li>
                                The remaining cases with
                                this "double black" node can
                                be categorized as follows:</li>
                                1) The sibling of the
                                "double black" node is black
                                and has a red child.<br>
                                2) The sibling of the
                                "double black" node is black
                                and both children are black.<br>
                                3) The sibling of the
                                "double black" node is red.<br>
                                (Note that initially, even
                                though the double black node
                                is a null node, after
                                starting the
                                recoloring/restructuring
                                process, we may create a
                                double black node that is
                                NOT null.)<br>
                                <li>
                                To deal with each of these
                                situations, let's first set
                                up names for all of the
                                important nodes: </li>
                                1) Let the child of the
                                deleted node, which is
                                colored "double black" be r.<br>
                                2) Let y be the sibling of
                                r.<br>
                            3) Let z be a child of y, in
                            each case, the specific child
                            will be designated.<br>
                            4) Let x be the parent of y.<br>
                            </ul>
                            <b>Case 1: </b>y is black and has a red child z.<br>
                            This case corresponds to the transfer operation in a 2-4 Tree delete. Take the nodes, x, y, and z and relabel them a, b, and c, in their inorder ordering. Place b where x used to be, and then have a and c be the left and right children of x, respectively. Color a and c black, and color b whatever color x USED to be. This eliminates the "double black" problem, so we can stop here.
                            <br>
                            <b>Case 2:</b> y is black and both of its children are as well.<br>
                            This case corresponds to a fusion operation in a 2-4 Tree. We deal with this case by just recoloring, instead of making any structural changes to the tree. In particular, we will color r black, (changing it from "double black") and then color y red. What this does is subtract one from the black depth of every external node in the subtree of x. To compensate for this, we must change x from red to black. BUT, this only works if x was red to begin with!!! If it's not, to maintain the "black depth" at the external nodes in the subtree rooted at x, we must color x "double black." In essence, if this occurs, we have pushed the "double black" node up the tree, much like a fusion operation can propogate another fusion operation.
                            </p>
                            <!--                         Let <b>v</b> be the node to be deleted.
                                 Let <b>u</b> be only the child  of v.
                                 Case1. Either v or u is red
                                 <ul>
                                 <li>Replace v by u,u will be a black node</li>
                                 </ul>
                                 Case2. Both u and v are black.
                                 <ul>
                                 <li> If node u is root, make it a single black node</li>
                                 <li> <b>NOTE</b>: This violates the property of red black trees,as number of black nodes from root to descendant nodes must be constant.Here earlier it was 2, but now it is reduced to 1.
                                 </li>
                                 <li>To overcome this we represent single node by a double black node, by depicting it with an extra black circle.</li>
                                 <li>
                                 The next task is to reduce this double black node to a single node.</li>
                                 <li> If u is a root node, we can directly reduce the double black node to a single black node</li>
                                 <li>Else , we have 4 subcases to be handled.
                                 </li>
                                 Let w be sibling node of w.
                                 If w is black and both the children of w are black.
                                 <ul>
                                 <li></li>
                                 <li></li>
                                 </ul>
                                 If w is red
                                 <ul>
                                 <li>Exchange colors of sibling node and parent node</li>
                                 <li>
                                 Perform left rotation on the parent node.
                                 </li>
                                 </ul>
                                 </ul> -->
                        </div>
                    </div>
                </div>
                <div class="task" title="Search">
                    <div class="longt">
                        <h2 class="hlongt">Searching in a Red Black Tree</h2>
                    </div>
                    <div class="art txt" title="Search in a Red Black Tree">
                        <div class="longt">
                            <h2 class="hlongt">Search in a Red Black Tree</h2>
                        </div>
                        <div class="art-body">
                            Search in Red Black Tree is similar to search in Binary Search Tree.
                            Let the node to be search be X.
                            <ul>
                                <li>If value of X is less than root node, we traverse recursively along the left subtree.</li>
                                <li>If the value of X  is greater than the root node, we traverse recursively along the right subtree</li>
                            </ul>
                        </div>
                    </div>
                </div>
                <div class="task" title="Red Black Tree Demo">
                    <div class="longt">
                        <h2 class="hlongt">Hands-on Demo on Red Black Tree</h2>
                    </div>
                    <div class="art req" title="Red Black Tree Demo">
                        <div class="longt">
                            <h2 class="hlongt">Hands-on Demo on Red Black Tree</h2>
                        </div>
                        <div class="description">
                            <p>Student is given a tree and starting node as the question.
                                <br>
                                Student needs to click the nodes of tree as they appear in DFT algorithm
                                <br>
                                Nodes follow a particular color scheme to differentiate between white,grey and black nodes.
                            </p>
                        </div>
                    </div>
                </div>
                <div class="task" title="Red Black Tree Practice">
                    <div class="longt">
                        <h2 class="hlongt">Hands-on Practice on Red Black Tree</h2>
                    </div>
                    <div class="art req" title="Red Black Tree Practice">
                        <div class="longt">
                            <h2 class="hlongt">Hands-on Practice on Red Black Tree</h2>
                        </div>
                        <div class="description">
                            <p>Student is given a tree and starting node as the question.
                                <br>
                                Student needs to click the nodes of tree as they appear in DFT algorithm
                                <br>
                                Nodes follow a particular color scheme to differentiate between white,grey and black nodes.
                            </p>
                        </div>
                    </div>
                </div>
                <div class="task" title="Red Black Tree Exercise">
                    <div class="longt">
                        <h2 class="hlongt">Hands-on exercise on Red Black Tree</h2>
                    </div>
                    <div class="art req" title="Red Black Tree Exercise">
                        <div class="longt">
                            <h2 class="hlongt">Hands-on exercise on Red Black Tree</h2>
                        </div>
                        <div class="description">
                            <p>Student is given a tree and starting node as the question.
                                <br>
                                Student needs to click the nodes of tree as they appear in DFT algorithm
                                <br>
                                Nodes follow a particular color scheme to differentiate between white,grey and black nodes.
                            </p>
                        </div>
                    </div>
                </div>

                <div class="quiz" title="Red Black Tree operations Quiz">
                    <div class="longt">
                        <h2 class="hlongt">Post Test Quiz of the Experiment</h2>
                    </div>
                    
                    <div class="mcq">
                        <div class="preamble">
                            <div class="art txt" title="qi">
                                <div class="art-body">
                                    <p>Q1. Time Complexity of insertion in Red Black Tree with n nodes is ______.
                                    </p>
                                </div>
                            </div>
                        </div>
                        
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="qi-c4">
                                    <div class="art-body">
                                        <p>(A) None of the mentioned </p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="qi-c2">
                                    <div class="art-body">
                                        <p>(B) O(n) </p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        
                        <div class="choice" data-correct="true">
                            <div class="preamble">
                                <div class="art txt" title="qi-c1">
                                    <div class="art-body">
                                        <p>(C) O(log n) </p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="qi-c3">
                                    <div class="art-body">
                                        <p>(D) O(1) </p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        
                        <div class="explanation">
                            <div class="art txt" title="Explanation">
                                <div class="art-body">
                                    <p>The rotation algorithm ensures the operation is done with O(log n)
                                        time complexity.</p>
                                </div>
                            </div>
                        </div>
                    </div>
                    
                    <div class="mcq">
                        <div class="preamble">
                            <div class="art txt" title="qi">
                                <div class="art-body">
                                    <p>Q2. How do we impose restrictions?
                                        <ol>
                                            <li>root property is black</li>
                                            <li>every leaf is black</li>
                                            <li>children of red node are black</li>
                                            <li>all leaves have same black</li>
                                        </ol>
                                    </p>
                                </div>
                            </div>
                        </div>
                        
                        <div class="choice" data-correct="true">
                            <div class="preamble">
                                <div class="art txt" title="qi-c1">
                                    <div class="art-body">
                                        <p>(A) Any one of the given three traversals is sufficient </p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="qi-c2">
                                    <div class="art-body">
                                        <p>(B) Either 2 or 3 is sufficient </p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="qi-c4">
                                    <div class="art-body">
                                        <p>(C) 1 and 3 </p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="qi-c3">
                                    <div class="art-body">
                                        <p>(D) 2 and 3 </p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        
                        <div class="explanation">
                            <div class="art txt" title="Explanation">
                                <div class="art-body">
                                    <p>All the operations ensure the the maximum height of the tree is log
                                        n. Hence all the operations take a logarithmic time complexity.</p>
                                </div>
                            </div>
                        </div>
                    </div>
                    
                </div>
            </div>
            <div class="lu" title="Post-Test">
                <div class="longt">
                    <h2 class="hlongt">Post Test </h2>
                </div>
                <div class="preamble">
                    <div class="art txt" title="Estimation">
                        <div class="longt">
                            <h2 class="hlongt">Estimated Time</h2>
                        </div>
                        <div class="art-body">
                            <p>10 minutes</p>
                        </div>
                    </div>
                    <div class="art txt" title="Instructions">
                        <div class="longt">
                            <h2 class="hlongt">Introduction for Post test</h2>
                        </div>
                        <div class="art-body">
                            <p>Post test includes questions on
                                entire experiment concepts. Read the
                                questions given below and select the
                                correct option from the ones
                                provided. Please note that some
                                questions may have more than one
                                correct response.
                            </p>
                        </div>
                    </div>
                </div>

                <div class="quiz" title="Post Test Quiz">
                    <div class="longt">
                        <h2 class="hlongt">Post Test Quiz of the Experiment</h2>
                    </div>
                    
                    <div class="mcq">
                        <div class="preamble">
                            <div class="art txt" title="qi">
                                <div class="art-body">
                                    <p>Q1. Time Complexity of insertion in Red Black Tree with n nodes is ______.
                                    </p>
                                </div>
                            </div>
                        </div>
                        
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="qi-c4">
                                    <div class="art-body">
                                        <p>(A) None of the mentioned </p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="qi-c2">
                                    <div class="art-body">
                                        <p>(B) O(n) </p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        
                        <div class="choice" data-correct="true">
                            <div class="preamble">
                                <div class="art txt" title="qi-c1">
                                    <div class="art-body">
                                        <p>(C) O(log n) </p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="qi-c3">
                                    <div class="art-body">
                                        <p>(D) O(1) </p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        
                        <div class="explanation">
                            <div class="art txt" title="Explanation">
                                <div class="art-body">
                                    <p>The rotation algorithm ensures the operation is done with O(log n)
                                        time complexity.</p>
                                </div>
                            </div>
                        </div>
                    </div>
                    
                    <div class="mcq">
                        <div class="preamble">
                            <div class="art txt" title="qi">
                                <div class="art-body">
                                    <p>Q2. Breadth First Traversal of a tree can be used for ____________.</p>
                                </div>
                            </div>
                        </div>
                        
                        <div class="choice" data-correct="true">
                            <div class="preamble">
                                <div class="art txt" title="qi-c1">
                                    <div class="art-body">
                                        <p>(A) Finding the shortest distance to every other node from the root in the tree. </p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="qi-c4">
                                    <div class="art-body">
                                        <p>(B) None of the Above. </p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="qi-c3">
                                    <div class="art-body">
                                        <p>(C) Finding strongly connected components in the tree. </p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="qi-c2">
                                    <div class="art-body">
                                        <p>(D) Finding cycles in the tree. </p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        
                        <div class="explanation">
                            <div class="art txt" title="Explanation">
                                <div class="art-body">
                                    <p>Breadth First traversal can be used to find the shortest distance to every other node from the root in the tree.</p>
                                </div>
                            </div>
                        </div>
                    </div>
                    
                    <div class="mcq">
                        <div class="preamble">
                            <div class="art txt" title="qi">
                                <div class="art-body">
                                    <p>Q3. What is common in three different types of traversals (Inorder, Preorder and Postorder)?</p>
                                </div>
                            </div>
                        </div>
                        
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="qi-c3">
                                    <div class="art-body">
                                        <p>(A) Root is visited before the right subtree. </p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        
                        <div class="choice" data-correct="true">
                            <div class="preamble">
                                <div class="art txt" title="qi-c1">
                                    <div class="art-body">
                                        <p>(B) Left subtree is always visited before the right subtree. </p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="qi-c2">
                                    <div class="art-body">
                                        <p>(C) Root is visited after the left subtree. </p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="qi-c4">
                                    <div class="art-body">
                                        <p>(D) All of the above. </p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        
                        <div class="explanation">
                            <div class="art txt" title="Explanation">
                                <div class="art-body">
                                    <p>In all traversals mentioned in the question, left subtee is traversed before the right subtree.</p>
                                </div>
                            </div>
                        </div>
                    </div>
                    
                    <div class="mcq">
                        <div class="preamble">
                            <div class="art txt" title="qi">
                                <div class="art-body">
                                    <p>Q4. A binary tree can be uniquely re-constructed from ____________.</p>
                                </div>
                            </div>
                        </div>
                        
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="qi-c4">
                                    <div class="art-body">
                                        <p>(A) All of the above. </p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="qi-c2">
                                    <div class="art-body">
                                        <p>(B) Preorder and Postorder traversal. </p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        
                        <div class="choice" data-correct="true">
                            <div class="preamble">
                                <div class="art txt" title="qi-c1">
                                    <div class="art-body">
                                        <p>(C) Inorder and Preorder traversal. </p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="qi-c3">
                                    <div class="art-body">
                                        <p>(D) Only Inorder traversal. </p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        
                        <div class="explanation">
                            <div class="art txt" title="Explanation">
                                <div class="art-body">
                                    <p>A binary tree can be uniquely reconstructed from its inorder and post order traversal.</p>
                                </div>
                            </div>
                        </div>
                    </div>
                    
                    <div class="mcq">
                        <div class="preamble">
                            <div class="art txt" title="qi">
                                <div class="art-body">
                                    <p>Q5. The inorder and preorder traversal of a binary tree are d b e a f c g and a b d e c f g respectively. The postorder traversal of the binary tree is____________.</p>
                                </div>
                            </div>
                        </div>
                        
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="qi-c4">
                                    <div class="art-body">
                                        <p> d e b f g a c </p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        
                        <div class="choice" data-correct="true">
                            <div class="preamble">
                                <div class="art txt" title="qi-c1">
                                    <div class="art-body">
                                        <p> d e b f g c a </p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="qi-c3">
                                    <div class="art-body">
                                        <p> e d b g f c a </p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        
                        <div class="choice" data-correct="false">
                            <div class="preamble">
                                <div class="art txt" title="qi-c2">
                                    <div class="art-body">
                                        <p> d e f g b c a </p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        
                        <div class="explanation">
                            <div class="art txt" title="Explanation">
                                <div class="art-body">
                                    <p>From the given preorder traversal, we know that the root of the tree is 'a'. Thus, 'a' must be the last element in the post order traversal. Now, after re-constructing the tree, we can easily find its post order traversal.
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>
                    
                </div>
                
                
            </div>
            <div class="lu" title="Further Readings/References">
                <div class="longt">
                    <h2 class="hlongt">Further Readings and References of the Experiment</h2>
                </div>
                <div class="preamble">
                    <div class="art txt" title="Explore">
                        <div class="longt">
                            <h2 class="hlongt">Explore Tree Traversal</h2>
                        </div>
                        <div class="art-body">
                            <p>You can explore more about tree traversal through following resources:</p>
                            <p>
                                <h4>Theory</h4>
                                <ul>
                                    <li><a href="https://www.geeksforgeeks.org/tree-traversals-inorder-preorder-and-postorder/">Concept</a></li>
                                    <li><a href="https://www.hackerearth.com/practice/notes/iterative-tree-traversals/">Iterative Traversal of Tree</a></li>
                                    <li><a href="https://en.wikipedia.org/wiki/Tree_traversal">Wikipedia</a></li>
                                </ul>
                            </p>
                            <p>
                                <h4>Practice</h4>
                                <ul>
                                    <li><a href="https://opendsa-server.cs.vt.edu/ODSA/Books/Everything/html/BinaryTreeTraversal.html">OpenDSA</a></li>
                                </ul>
                            </p>
                            <p>
                                <h4>Quizzes</h4>
                                <ul>
                                    <li><a href="https://www.sanfoundry.com/data-structure-questions-answers-inorder-traversal/">Questions and Answers</a></li>
                                </ul>
                            </p>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <script type="text/javascript" src="./js/loader.js"></script>
    </body>
</html>
